function [] = dispmfs(fismat); 
 
%DISPMF   Plot membership functions of all in- and output variables 
% 
%		  dispmfs(FISMATRIX);
%
% See also PLOTMF, FUZZY. 

% Author: Andreas Nuernberger, TU Braunschweig, August 1996; a.nuernberger@tu-bs.de
%         contact: Ludger Merz, DASA-Airbus GmbH, Hamburg; ludger.merz@airbus.de
 
if nargin ~= 1, 
	error('Too many or too few input arguments!'); 
end 
 
NumInputs	= getfis(fismat, 'NumInputs'); 
NumOutputs	= getfis(fismat, 'NumOutputs'); 
 
mftotal = max(NumInputs, NumOutputs); 
 
%inputs: 
for i=1:NumInputs, 
    subplot(mftotal, 2, i*2-1); 
	plotmf(fismat, 'input', i); 
end 
 
%outputs: 
for i=1:NumOutputs, 
    subplot(mftotal, 2, i*2); 
	plotmf(fismat, 'output', i); 
end 
 
pos = get(gcf, 'Position'); 
x = pos(3); 
cl = uicontrol(gcf, 'style','pushbutton',...  
                   'position',[x-120 3 100 20],...  
                   'Callback', 'close(gcf);',...  
                   'string', 'Close');  
 
