function [ret,x0,str,ts,xts]=sample1b(t,x,u,flag);
%SAMPLE1B	is the M-file description of the SIMULINK system named SAMPLE1B.
%	The block-diagram can be displayed by typing: SAMPLE1B.
%
%	SYS=SAMPLE1B(T,X,U,FLAG) returns depending on FLAG certain
%	system values given time point, T, current state vector, X,
%	and input vector, U.
%	FLAG is used to indicate the type of output to be returned in SYS.
%
%	Setting FLAG=1 causes SAMPLE1B to return state derivatives, FLAG=2
%	discrete states, FLAG=3 system outputs and FLAG=4 next sample
%	time. For more information and other options see SFUNC.
%
%	Calling SAMPLE1B with a FLAG of zero:
%	[SIZES]=SAMPLE1B([],[],[],0),  returns a vector, SIZES, which
%	contains the sizes of the state vector and other parameters.
%		SIZES(1) number of states
%		SIZES(2) number of discrete states
%		SIZES(3) number of outputs
%		SIZES(4) number of inputs
%		SIZES(5) number of roots (currently unsupported)
%		SIZES(6) direct feedthrough flag
%		SIZES(7) number of sample times
%
%	For the definition of other parameters in SIZES, see SFUNC.
%	See also, TRIM, LINMOD, LINSIM, EULER, RK23, RK45, ADAMS, GEAR.

% Note: This M-file is only used for saving graphical information;
%       after the model is loaded into memory an internal model
%       representation is used.

% the system will take on the name of this mfile:
sys = mfilename;
new_system(sys)
simver(1.3)
if (0 == (nargin + nargout))
     set_param(sys,'Location',[7,46,579,316])
     open_system(sys)
end;
set_param(sys,'algorithm',     'RK-45')
set_param(sys,'Start time',    '0.0')
set_param(sys,'Stop time',     '70')
set_param(sys,'Min step size', '0.5')
set_param(sys,'Max step size', '0.5')
set_param(sys,'Relative error','1e-3')
set_param(sys,'Return vars',   '')


%     Subsystem  ['Nefcon',13,'System'].

new_system([sys,'/',['Nefcon',13,'System']])
set_param([sys,'/',['Nefcon',13,'System']],'Location',[350,404,888,586])
set_param([sys,'/',['Nefcon',13,'System']],...
		'Mask Display','Nefcon\nSystem',...
		'Mask Type','Nefcon',...
		'Mask Dialogue','eval(''nefgui'')')


%     Finished composite block ['Nefcon',13,'System'].

set_param([sys,'/',['Nefcon',13,'System']],...
		'BackGround',3,...
		'Drop Shadow',4,...
		'position',[505,4,560,56])

add_block('built-in/Scope',[sys,'/','Scope1'])
set_param([sys,'/','Scope1'],...
		'Vgain','3.000000',...
		'Hgain','70.000000',...
		'Vmax','6.000000',...
		'Hmax','140.000000',...
		'Window',[605,2,910,286])
open_system([sys,'/','Scope1'])
set_param([sys,'/','Scope1'],...
		'position',[530,105,560,135])

add_block('built-in/Mux',[sys,'/','Mux2'])
set_param([sys,'/','Mux2'],...
		'inputs','2',...
		'position',[485,101,515,134])


%     Subsystem  'Nefcon-SigGen'.

new_system([sys,'/','Nefcon-SigGen'])
set_param([sys,'/','Nefcon-SigGen'],'Location',[363,444,906,748])

add_block('built-in/Signal Generator',[sys,'/',['Nefcon-SigGen/Signal Gen.',13,'f_rad=2*pi*f_Hz']])
set_param([sys,'/',['Nefcon-SigGen/Signal Gen.',13,'f_rad=2*pi*f_Hz']],...
		'Peak','0.500000',...
		'Peak Range','5.000000',...
		'Freq','0.100000',...
		'Freq Range','0.500000',...
		'Wave','Sqr',...
		'Units','Rads')
set_param([sys,'/',['Nefcon-SigGen/Signal Gen.',13,'f_rad=2*pi*f_Hz']],...
		'position',[70,59,110,81])

add_block('built-in/Constant',[sys,'/','Nefcon-SigGen/Constant'])
set_param([sys,'/','Nefcon-SigGen/Constant'],...
		'position',[155,125,175,145])

add_block('built-in/Gain',[sys,'/','Nefcon-SigGen/Gain1'])
set_param([sys,'/','Nefcon-SigGen/Gain1'],...
		'position',[355,119,410,151])

add_block('built-in/Sum',[sys,'/','Nefcon-SigGen/Sum'])
set_param([sys,'/','Nefcon-SigGen/Sum'],...
		'inputs','-++',...
		'position',[290,38,320,232])

add_block('built-in/Outport',[sys,'/','Nefcon-SigGen/out_1'])
set_param([sys,'/','Nefcon-SigGen/out_1'],...
		'position',[440,125,460,145])

add_block('built-in/Constant',[sys,'/','Nefcon-SigGen/Constant1'])
set_param([sys,'/','Nefcon-SigGen/Constant1'],...
		'Value','0',...
		'position',[150,240,170,260])

add_block('built-in/Switch',[sys,'/','Nefcon-SigGen/Switch'])
set_param([sys,'/','Nefcon-SigGen/Switch'],...
		'Threshold','0.5',...
		'position',[200,167,225,233])

add_block('built-in/Gain',[sys,'/','Nefcon-SigGen/Gain'])
set_param([sys,'/','Nefcon-SigGen/Gain'],...
		'Gain','0.4',...
		'position',[90,164,145,196])

add_block('built-in/Signal Generator',[sys,'/','Nefcon-SigGen/Rauschen'])
set_param([sys,'/','Nefcon-SigGen/Rauschen'],...
		'Peak','0.500000',...
		'Peak Range','5.000000',...
		'Freq','1.000000',...
		'Freq Range','5.000000',...
		'Wave','Rnd',...
		'Units','Rads',...
		'position',[25,169,65,191])


%     Subsystem  'Nefcon-SigGen/Get Signal'.

new_system([sys,'/','Nefcon-SigGen/Get Signal'])
set_param([sys,'/','Nefcon-SigGen/Get Signal'],'Location',[200,498,478,742])

add_block('built-in/S-Function',[sys,'/','Nefcon-SigGen/Get Signal/S-Function1'])
set_param([sys,'/','Nefcon-SigGen/Get Signal/S-Function1'],...
		'function name','getsig',...
		'parameters','width,name',...
		'position',[65,48,115,72])

add_block('built-in/Outport',[sys,'/','Nefcon-SigGen/Get Signal/out_1'])
set_param([sys,'/','Nefcon-SigGen/Get Signal/out_1'],...
		'position',[125,50,145,70])
add_line([sys,'/','Nefcon-SigGen/Get Signal'],[120,60;120,60])
set_param([sys,'/','Nefcon-SigGen/Get Signal'],...
		'Mask Display','GETSIG',...
		'Mask Type','GEt Signal',...
		'Mask Dialogue','Put a signal into the MATLAB workspace.  Specify the signal width and name. | Signal Width: | Name (in quotes):')
set_param([sys,'/','Nefcon-SigGen/Get Signal'],...
		'Mask Translate','width=@1;name=@2;')
set_param([sys,'/','Nefcon-SigGen/Get Signal'],...
		'Mask Help','Get signal from the MATLAB workspace. To be used in conjunction with PUTSIG. Names must be entered as strings.  The code for this block is getsig.c')
set_param([sys,'/','Nefcon-SigGen/Get Signal'],...
		'Mask Entries','1\/''NEFCON_NOISE''\/')


%     Finished composite block 'Nefcon-SigGen/Get Signal'.

set_param([sys,'/','Nefcon-SigGen/Get Signal'],...
		'position',[35,210,95,250])
add_line([sys,'/','Nefcon-SigGen'],[180,135;285,135])
add_line([sys,'/','Nefcon-SigGen'],[70,180;85,180])
add_line([sys,'/','Nefcon-SigGen'],[115,70;285,70])
add_line([sys,'/','Nefcon-SigGen'],[415,135;435,135])
add_line([sys,'/','Nefcon-SigGen'],[325,135;350,135])
add_line([sys,'/','Nefcon-SigGen'],[230,200;285,200])
add_line([sys,'/','Nefcon-SigGen'],[150,180;195,180])
add_line([sys,'/','Nefcon-SigGen'],[175,250;180,250;180,220;195,220])
add_line([sys,'/','Nefcon-SigGen'],[100,230;140,230;140,200;195,200])
set_param([sys,'/','Nefcon-SigGen'],...
		'Mask Display','NEFCON\nSigGen')


%     Finished composite block 'Nefcon-SigGen'.

set_param([sys,'/','Nefcon-SigGen'],...
		'BackGround',3,...
		'hide name',0,...
		'position',[10,80,80,130])

add_block('built-in/To Workspace',[sys,'/','Signal'])
set_param([sys,'/','Signal'],...
		'BackGround',3,...
		'mat-name','nef_u',...
		'buffer','10000',...
		'Mask Display','nef_u',...
		'position',[100,40,160,60])

add_block('built-in/To Workspace',[sys,'/','Response'])
set_param([sys,'/','Response'],...
		'BackGround',3,...
		'mat-name','nef_y',...
		'buffer','10000',...
		'Mask Display','nef_y',...
		'position',[490,230,550,250])


%     Subsystem  'Fuzzi'.

new_system([sys,'/','Fuzzi'])
set_param([sys,'/','Fuzzi'],'Location',[246,697,817,831])

add_block('built-in/Outport',[sys,'/','Fuzzi/out_1'])
set_param([sys,'/','Fuzzi/out_1'],...
		'position',[465,5,485,25])

add_block('built-in/Gain',[sys,'/','Fuzzi/GainOut'])
set_param([sys,'/','Fuzzi/GainOut'],...
		'position',[415,5,435,25])

add_block('built-in/Mux',[sys,'/','Fuzzi/Mux1'])
set_param([sys,'/','Fuzzi/Mux1'],...
		'inputs','2',...
		'position',[415,60,445,80])

add_block('built-in/Scope',[sys,'/','Fuzzi/Error'])
set_param([sys,'/','Fuzzi/Error'],...
		'BackGround',3,...
		'Vgain','2.000000',...
		'Hgain','70.000000',...
		'Vmax','4.000000',...
		'Hmax','140.000000',...
		'Window',[18,139,322,414],...
		'position',[465,60,485,80])

add_block('built-in/Saturation',[sys,'/','Fuzzi/Saturation2'])
set_param([sys,'/','Fuzzi/Saturation2'],...
		'Lower Limit','-1',...
		'Upper Limit','1',...
		'position',[135,80,160,100])

add_block('built-in/Gain',[sys,'/','Fuzzi/GainIn2'])
set_param([sys,'/','Fuzzi/GainIn2'],...
		'Gain','2',...
		'position',[70,80,90,100])

add_block('built-in/Inport',[sys,'/','Fuzzi/in_2'])
set_param([sys,'/','Fuzzi/in_2'],...
		'Port','2',...
		'position',[20,80,40,100])

add_block('built-in/Mux',[sys,'/','Fuzzi/Mux'])
set_param([sys,'/','Fuzzi/Mux'],...
		'inputs','2',...
		'position',[200,9,230,116])

add_block('built-in/Saturation',[sys,'/','Fuzzi/Saturation1'])
set_param([sys,'/','Fuzzi/Saturation1'],...
		'Lower Limit','-1',...
		'Upper Limit','1',...
		'position',[135,25,160,45])

add_block('built-in/Gain',[sys,'/','Fuzzi/GainIn1'])
set_param([sys,'/','Fuzzi/GainIn1'],...
		'Gain','2',...
		'position',[70,25,90,45])

add_block('built-in/Inport',[sys,'/','Fuzzi/in_1'])
set_param([sys,'/','Fuzzi/in_1'],...
		'position',[20,25,40,45])

add_block('built-in/Stop Simulation',[sys,'/','Fuzzi/Stop Simulation'])
set_param([sys,'/','Fuzzi/Stop Simulation'],...
		'position',[420,115,460,135])

add_block('built-in/S-Function',[sys,'/',['Fuzzi/Nefcon ',13,'Lern-System']])
set_param([sys,'/',['Fuzzi/Nefcon ',13,'Lern-System']],...
		'function name','snefcon',...
		'position',[265,45,320,85])

add_block('built-in/Demux',[sys,'/','Fuzzi/Demux'])
set_param([sys,'/','Fuzzi/Demux'],...
		'outputs','3',...
		'position',[335,45,375,85])
add_line([sys,'/','Fuzzi'],[45,35;65,35])
add_line([sys,'/','Fuzzi'],[95,35;130,35])
add_line([sys,'/','Fuzzi'],[165,35;195,35])
add_line([sys,'/','Fuzzi'],[45,90;65,90])
add_line([sys,'/','Fuzzi'],[95,90;130,90])
add_line([sys,'/','Fuzzi'],[165,90;195,90])
add_line([sys,'/','Fuzzi'],[235,65;260,65])
add_line([sys,'/','Fuzzi'],[325,65;330,65])
add_line([sys,'/','Fuzzi'],[380,50;395,50;395,15;410,15])
add_line([sys,'/','Fuzzi'],[440,15;460,15])
add_line([sys,'/','Fuzzi'],[380,65;410,65])
add_line([sys,'/','Fuzzi'],[450,70;460,70])
add_line([sys,'/','Fuzzi'],[380,80;395,80;395,125;415,125])
set_param([sys,'/','Fuzzi'],...
		'Mask Display','NEFCON\nFuzzy')


%     Finished composite block 'Fuzzi'.

set_param([sys,'/','Fuzzi'],...
		'BackGround',3,...
		'hide name',0,...
		'position',[220,87,280,178])

add_block('built-in/Scope',[sys,'/','Scope4'])
set_param([sys,'/','Scope4'],...
		'Vgain','2.000000',...
		'Hgain','70.000000',...
		'Vmax','4.000000',...
		'Hmax','140.000000',...
		'Window',[410,361,736,593],...
		'position',[190,35,220,65])

add_block('built-in/Scope',[sys,'/','Scope3'])
set_param([sys,'/','Scope3'],...
		'Vgain','2.000000',...
		'Hgain','70.000000',...
		'Vmax','4.000000',...
		'Hmax','140.000000',...
		'Window',[606,290,910,555])
open_system([sys,'/','Scope3'])
set_param([sys,'/','Scope3'],...
		'position',[305,35,335,65])

add_block('built-in/Constant',[sys,'/',['tank max',13,'inflow']])
set_param([sys,'/',['tank max',13,'inflow']],...
		'orientation',2,...
		'Value','0.5',...
		'position',[330,194,375,226])

add_block('built-in/Scope',[sys,'/','Scope2'])
set_param([sys,'/','Scope2'],...
		'orientation',2,...
		'Vgain','2.000000',...
		'Hgain','20.000000',...
		'Vmax','4.000000',...
		'Hmax','40.000000',...
		'Window',[207,553,469,687],...
		'position',[410,195,440,225])


%     Subsystem  'tank 2'.

new_system([sys,'/','tank 2'])
set_param([sys,'/','tank 2'],'Location',[109,460,655,768])

add_block('built-in/Gain',[sys,'/','tank 2/1//Height'])
set_param([sys,'/','tank 2/1//Height'],...
		'Gain','1/ht',...
		'position',[185,77,235,133])

add_block('built-in/Outport',[sys,'/',['tank 2/overflow',13,'flag']])
set_param([sys,'/',['tank 2/overflow',13,'flag']],...
		'Port','3',...
		'position',[495,30,515,50])

add_block('built-in/Outport',[sys,'/',['tank 2/water',13,'level']])
set_param([sys,'/',['tank 2/water',13,'level']],...
		'position',[495,100,515,120])

add_block('built-in/Gain',[sys,'/','tank 2/1//area'])
set_param([sys,'/','tank 2/1//area'],...
		'Gain','1/area',...
		'position',[220,167,270,223])

add_block('built-in/Gain',[sys,'/','tank 2/outletArea'])
set_param([sys,'/','tank 2/outletArea'],...
		'Gain','outletArea',...
		'position',[410,167,460,223])

add_block('built-in/Fcn',[sys,'/','tank 2/sqrt(2gh)'])
set_param([sys,'/','tank 2/sqrt(2gh)'],...
		'Expr','sqrt(2*9.8*u)',...
		'position',[300,171,390,219])


%     Subsystem  ['tank 2/tank',13,'volume'].

new_system([sys,'/',['tank 2/tank',13,'volume']])
set_param([sys,'/',['tank 2/tank',13,'volume']],'Location',[0,0,791,233])

add_block('built-in/Saturation',[sys,'/',['tank 2/tank',13,'volume/Saturation']])
set_param([sys,'/',['tank 2/tank',13,'volume/Saturation']],...
		'Lower Limit','lb',...
		'Upper Limit','ub',...
		'position',[630,121,675,149])

add_block('built-in/Fcn',[sys,'/',['tank 2/tank',13,'volume/Fcn']])
set_param([sys,'/',['tank 2/tank',13,'volume/Fcn']],...
		'Expr','u[2]*((((u[1]>lb)+(u[2]>=0))>0) * (((u[1]<ub)+(u[2]<=0))>0))',...
		'position',[150,116,520,154])

add_block('built-in/Inport',[sys,'/',['tank 2/tank',13,'volume/In_1']])
set_param([sys,'/',['tank 2/tank',13,'volume/In_1']],...
		'position',[20,130,40,150])

add_block('built-in/Outport',[sys,'/',['tank 2/tank',13,'volume/Out_1']])
set_param([sys,'/',['tank 2/tank',13,'volume/Out_1']],...
		'position',[720,125,740,145])

add_block('built-in/Integrator',[sys,'/',['tank 2/tank',13,'volume/Integrator']])
set_param([sys,'/',['tank 2/tank',13,'volume/Integrator']],...
		'Initial','xi',...
		'position',[540,126,585,144])

add_block('built-in/Mux',[sys,'/',['tank 2/tank',13,'volume/Mux']])
set_param([sys,'/',['tank 2/tank',13,'volume/Mux']],...
		'inputs','2',...
		'position',[85,116,115,149])
add_line([sys,'/',['tank 2/tank',13,'volume']],[680,135;715,135])
add_line([sys,'/',['tank 2/tank',13,'volume']],[45,140;80,140])
add_line([sys,'/',['tank 2/tank',13,'volume']],[120,135;145,135])
add_line([sys,'/',['tank 2/tank',13,'volume']],[525,135;535,135])
add_line([sys,'/',['tank 2/tank',13,'volume']],[590,135;625,135])
add_line([sys,'/',['tank 2/tank',13,'volume']],[600,135;600,35;55,35;55,125;80,125])
set_param([sys,'/',['tank 2/tank',13,'volume']],...
		'Mask Display','plot(-1,-0.2,3.5,1.2,[0.05,1,2,2.9],[0,0,1,1]); 1/s    ',...
		'Mask Type','Limited integrator.')
set_param([sys,'/',['tank 2/tank',13,'volume']],...
		'Mask Dialogue','Limited integrator|Lower bound:|Upper bound:|Initial condition',...
		'Mask Translate','lb = @1; ub = @2; xi = @3;')
set_param([sys,'/',['tank 2/tank',13,'volume']],...
		'Mask Help','Implements a limited integrator with \nan expression of the form:\n\nif(x<=lb and u<0) or (x>=ub and u>0)\n\txdot=0\nelse\n\txdot=u.')
set_param([sys,'/',['tank 2/tank',13,'volume']],...
		'Mask Entries','0\/ht * area\/initialHt * area\/')


%     Finished composite block ['tank 2/tank',13,'volume'].

set_param([sys,'/',['tank 2/tank',13,'volume']],...
		'position',[150,174,200,216])

add_block('built-in/Sum',[sys,'/','tank 2/sum'])
set_param([sys,'/','tank 2/sum'],...
		'inputs','+-',...
		'position',[105,175,125,210])

add_block('built-in/Inport',[sys,'/',['tank 2/flow',13,'in']])
set_param([sys,'/',['tank 2/flow',13,'in']],...
		'position',[25,175,45,195])

add_block('built-in/Relay',[sys,'/','tank 2/Overflow sensor'])
set_param([sys,'/','tank 2/Overflow sensor'],...
		'On_switch_value','ht - overflowLimit',...
		'Off_switch_value','ht - overflowLimit',...
		'position',[385,18,425,62])

add_block('built-in/Outport',[sys,'/',['tank 2/flow',13,'out']])
set_param([sys,'/',['tank 2/flow',13,'out']],...
		'Port','2',...
		'position',[495,185,515,205])
add_line([sys,'/','tank 2'],[130,195;145,195])
add_line([sys,'/','tank 2'],[50,185;100,185])
add_line([sys,'/','tank 2'],[430,40;490,40])
add_line([sys,'/','tank 2'],[205,195;215,195])
add_line([sys,'/','tank 2'],[275,195;295,195])
add_line([sys,'/','tank 2'],[395,195;405,195])
add_line([sys,'/','tank 2'],[465,195;490,195])
add_line([sys,'/','tank 2'],[475,195;475,260;85,260;85,200;100,200])
add_line([sys,'/','tank 2'],[275,195;285,195;285,40;380,40])
add_line([sys,'/','tank 2'],[285,110;490,110])
set_param([sys,'/','tank 2'],...
		'Mask Display','WATER\nTANK',...
		'Mask Type','Water tank')
set_param([sys,'/','tank 2'],...
		'Mask Dialogue','Cylindrical water tank with overflow signal|Height of tank (m):|Bottom area (m^2):|Out pipe crossection (m^2):|Overflow sensor distance from top (m):|Initial level height (m):')
set_param([sys,'/','tank 2'],...
		'Mask Translate','ht=@1;area=@2;outletArea=@3;overflowLimit=@4;initialHt=@5;',...
		'Mask Entries','2\/1\/0.05\/0\/0.5\/')


%     Finished composite block 'tank 2'.

set_param([sys,'/','tank 2'],...
		'position',[390,116,450,174])


%     Subsystem  'Subsystem'.

new_system([sys,'/','Subsystem'])
set_param([sys,'/','Subsystem'],'Location',[408,498,736,676])

add_block('built-in/Outport',[sys,'/','Subsystem/out flow'])
set_param([sys,'/','Subsystem/out flow'],...
		'position',[250,95,270,115])

add_block('built-in/Product',[sys,'/','Subsystem/Product'])
set_param([sys,'/','Subsystem/Product'],...
		'position',[180,76,215,134])


%     Subsystem  'Subsystem/Limited Integrator'.

new_system([sys,'/','Subsystem/Limited Integrator'])
set_param([sys,'/','Subsystem/Limited Integrator'],'Location',[0,0,791,233])

add_block('built-in/Saturation',[sys,'/','Subsystem/Limited Integrator/Saturation'])
set_param([sys,'/','Subsystem/Limited Integrator/Saturation'],...
		'Lower Limit','lb',...
		'Upper Limit','ub',...
		'position',[630,121,675,149])

add_block('built-in/Fcn',[sys,'/','Subsystem/Limited Integrator/Fcn'])
set_param([sys,'/','Subsystem/Limited Integrator/Fcn'],...
		'Expr','u[2]*((((u[1]>lb)+(u[2]>=0))>0) * (((u[1]<ub)+(u[2]<=0))>0))',...
		'position',[150,116,520,154])

add_block('built-in/Inport',[sys,'/','Subsystem/Limited Integrator/In_1'])
set_param([sys,'/','Subsystem/Limited Integrator/In_1'],...
		'position',[20,130,40,150])

add_block('built-in/Outport',[sys,'/','Subsystem/Limited Integrator/Out_1'])
set_param([sys,'/','Subsystem/Limited Integrator/Out_1'],...
		'position',[720,125,740,145])

add_block('built-in/Integrator',[sys,'/','Subsystem/Limited Integrator/Integrator'])
set_param([sys,'/','Subsystem/Limited Integrator/Integrator'],...
		'Initial','xi',...
		'position',[540,126,585,144])

add_block('built-in/Mux',[sys,'/','Subsystem/Limited Integrator/Mux'])
set_param([sys,'/','Subsystem/Limited Integrator/Mux'],...
		'inputs','2',...
		'position',[85,116,115,149])
add_line([sys,'/','Subsystem/Limited Integrator'],[680,135;715,135])
add_line([sys,'/','Subsystem/Limited Integrator'],[45,140;80,140])
add_line([sys,'/','Subsystem/Limited Integrator'],[120,135;145,135])
add_line([sys,'/','Subsystem/Limited Integrator'],[525,135;535,135])
add_line([sys,'/','Subsystem/Limited Integrator'],[590,135;625,135])
add_line([sys,'/','Subsystem/Limited Integrator'],[600,135;600,35;55,35;55,125;80,125])
set_param([sys,'/','Subsystem/Limited Integrator'],...
		'Mask Display','plot(-1,-0.2,3.5,1.2,[0.05,1,2,2.9],[0,0,1,1]); 1/s    ',...
		'Mask Type','Limited integrator.')
set_param([sys,'/','Subsystem/Limited Integrator'],...
		'Mask Dialogue','Limited integrator|Lower bound:|Upper bound:|Initial condition',...
		'Mask Translate','lb = @1; ub = @2; xi = @3;')
set_param([sys,'/','Subsystem/Limited Integrator'],...
		'Mask Help','Implements a limited integrator with \nan expression of the form:\n\nif(x<=lb and u<0) or (x>=ub and u>0)\n\txdot=0\nelse\n\txdot=u.')
set_param([sys,'/','Subsystem/Limited Integrator'],...
		'Mask Entries','0\/1\/InitialPosition\/')


%     Finished composite block 'Subsystem/Limited Integrator'.

set_param([sys,'/','Subsystem/Limited Integrator'],...
		'position',[80,9,130,51])

add_block('built-in/Inport',[sys,'/','Subsystem/source flow'])
set_param([sys,'/','Subsystem/source flow'],...
		'Port','2',...
		'position',[20,110,40,130])

add_block('built-in/Inport',[sys,'/','Subsystem/control'])
set_param([sys,'/','Subsystem/control'],...
		'position',[20,20,40,40])
add_line([sys,'/','Subsystem'],[135,30;160,30;160,90;175,90])
add_line([sys,'/','Subsystem'],[45,30;75,30])
add_line([sys,'/','Subsystem'],[220,105;245,105])
add_line([sys,'/','Subsystem'],[45,120;175,120])
set_param([sys,'/','Subsystem'],...
		'Mask Display','VALVE',...
		'Mask Type','Valve',...
		'Mask Dialogue','Valve|Initial position [0=closed 1=open]:',...
		'Mask Translate','InitialPosition = @1;',...
		'Mask Entries','0\/')


%     Finished composite block 'Subsystem'.

set_param([sys,'/','Subsystem'],...
		'position',[325,123,375,167])

add_block('built-in/Derivative',[sys,'/','Derivative'])
set_param([sys,'/','Derivative'],...
		'position',[160,140,195,170])

add_block('built-in/Sum',[sys,'/','error'])
set_param([sys,'/','error'],...
		'inputs','+-',...
		'position',[110,100,130,120])
add_line(sys,[520,120;525,120])
add_line(sys,[455,165;445,210])
add_line(sys,[380,145;385,145])
add_line(sys,[135,110;215,110])
add_line(sys,[325,210;310,210;320,155])
add_line(sys,[455,125;480,125])
add_line(sys,[200,155;215,155])
add_line(sys,[85,105;105,105])
add_line(sys,[95,105;85,105;85,20;465,20;465,110;480,110])
add_line(sys,[285,135;320,135])
add_line(sys,[455,125;465,125;465,260;85,260;85,115;105,115])
add_line(sys,[310,135;290,135;300,50])
add_line(sys,[135,110;175,110;185,50])
add_line(sys,[85,50;95,50])
add_line(sys,[465,240;485,240])
add_line(sys,[145,110;155,155])

drawnow

% Return any arguments.
if (nargin | nargout)
	% Must use feval here to access system in memory
	if (nargin > 3)
		if (flag == 0)
			eval(['[ret,x0,str,ts,xts]=',sys,'(t,x,u,flag);'])
		else
			eval(['ret =', sys,'(t,x,u,flag);'])
		end
	else
		[ret,x0,str,ts,xts] = feval(sys);
	end
else
	drawnow % Flash up the model and execute load callback
end
