function [sys, x0] = snefcon(t, x, u, flag, nefmat);  
%SNEFCON SIMULINK s-function calling NEFCON.
%
% See also NEFCON.  
   
% Author: Andreas Nuernberger, TU Braunschweig, August 1996; a.nuernberger@tu-bs.de
%         contact: Ludger Merz, DASA-Airbus GmbH, Hamburg; ludger.merz@airbus.de

 
% Globals:  
global NEFCON_STAT  
global LASTTIME SYSOLD UOLD 
global NEFCON_NUMIN  
global NEFCON_STOP  
global NEFCON_FIS
  
OUT = 3;          % output-, fuzzy_error, stop-signal  
IN = NEFCON_NUMIN;  
  
if flag == 0  
    if NEFCON_STAT == 0 | NEFCON_STAT == []  
        SYSOLD = nefcon(zeros(1,IN+1));  % init_nefcon  
        %SYSOLD = [0,0]
        LASTTIME = -1;  
    end  
    sys = [0, 0, OUT, IN, 0, 0];  
  
%    x0 =[0; 0]                      % ???  
  
elseif flag == 3  
    % prevent duplicate calls during one timestep
%    if LASTTIME ~= t | UOLD ~= u | SYSOLD == [] 
    if LASTTIME ~= t | UOLD ~= u
%        if LASTTIME == t   
%            out = evalfis(u', NEFCON_FIS)  
%            SYSOLD=[out; 0];   
%        else
            SYSOLD = nefcon([t u']); 
            LASTTIME = t; 
%        end
        UOLD = u;
    end  
    sys = [SYSOLD; NEFCON_STOP]; 
else  
  
    sys = [];  
  
end  
 
