function ferr = syserr(input, bound) 
%SYSERR Default external error function (using bounds) for NEFCON
% The return value must be in [-1,1].
% Parameters:
%  simulink system dependend:
%   input(1) dx     (P) 
%   input(2) dx'    (D) 
%   input(3) F(dx)  (I) 
%  generator dependend (only set if nefcon bounded signalgenerator is used)
%   bound(1) signal 
%   bound(2) upper bound 
%   bound(3) lower bound 
%   bound(4) system output 
%   bound(5) system output derivative 
%
% See also NEFGUI and NEFCON.  
   
% Author: Andreas Nuernberger, TU Braunschweig, August 1996; a.nuernberger@tu-bs.de
%         contact: Ludger Merz, DASA-Airbus GmbH, Hamburg; ludger.merz@airbus.de
 
 
ferr = input(1)*0.2; 
ferr = max(-1, min(ferr, 1));
 
