function pc = updatdlg(flag) 
%UPDATDLG updates the NCD dialog boxes. 
%       PC = UPDATDLG(FLAG) updates the appropriate NCD dialogs. 
%       updated version.
 
%	Author(s): A. Potvin, 12-1-92 
%	Copyright (c) 1992-93 by The MathWorks, Inc. 
%	$Revision: 1.8 $  $Date: 1993/08/26 13:31:33 $ 
%       Modified: Andreas Nuernberger; DASA Airbus; June 1996
 
% OVERHAUL: make this useful to more routines 
 
 
pc = ''; 
 
if strcmp(flag,'buncd'), 
   % Called from buncd 
   NCD_Fig = gcf; 
 
   % If Constraint Editor db is on screen, make necessary changes 
   if figflag('Constraint Editor'), 
      NCD_ud = get(NCD_Fig,'UserData'); 
      if any(NCD_ud(1,5)==[-1 4]) | (NCD_ud(1,3)==0), 
         % Not a motion mode where a segment is highlighted 
         delete(gcf); 
      else 
         coneddlg(0); 
      end 
   end 
 
elseif strcmp(flag,'nefoptf'), 
   % Called from optfig.m 
   global REF_SIG 
   fig = gcf; 
   ud = get(fig,'UserData'); 
   out = ud(1,2); 
 
   % If Reference Signal db is on screen, make necessary changes 
   if figflag(['Reference Signal for output ' int2str(out)]), 
      refdlg(5); 
      refdlg(4); 
   end 
   figure(fig) 
 
   % Pseudo Hack: plot command must be evaluated in base workspace  
   % because it could use base workspace variables, so bubble it up  
   if size(REF_SIG,1)>=2*out, 
      pc = ['figure(' int2str(fig) ');line(' REF_SIG(2*out-1,:) ... 
            ',' REF_SIG(2*out,:) ',''LineStyle'','':'');']; 
   else 
      pc = ''; 
   end 
 
elseif strcmp(flag,'loado'), 
   % Called from loado.m 
   global varstr UC_UV 
 
   % Declare Tunable and Uncertain Variables global in base workspace 
   if ~isempty(varstr) | ~isempty(UC_UV), 
      % Use eval('try','catch') 
      pc = 'eval([''global '' varstr UC_UV],''errorncd(2);'');'; 
   end 
 
   % If Uncertain Variables db is on screen, make necessary changes 
   if figflag('Uncertain Variables'), 
      uncerdlg(9); 
      uncerdlg(10); 
   end 
 
   % If Optimization Parameters db is on screen, make necessary changes 
   if figflag('Optimization Parameters'), 
      paramdlg(8); 
      paramdlg(9); 
   end 
 
end 
 
% end updatdlg 
